


 
int konstanta = 185;   // konstanta pro přepočet naměřeného napětí na proud 185 pro 5A, 100 pro 20A
int offset = 2510;    // proměnná pro nastavení offsetu, polovina Vcc
#include <LiquidCrystal.h>
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
  int analog= 0;    //Deklarace proměnných
  double napeti = 0; //měření proudu
  double proud = 0; //měření proudu
  double soucet = 0;//měření proudu
  double Imax=0;  //počáteční proud
  double Ivyp=0;  //vypínací proud
  double Isum=0;  //součet proudů
  double Iprum=0; //průměrný proud
  long cas = 0;   //čas měření 
  long cas_old=0; //čas pro výpočet prodlevy 1min pro odeslání na sér. port
  long x=0;
  float c=0;
   

  
void setup() { 
   pinMode(9, OUTPUT);  //Výstup pro připojení  relé 
   pinMode (8, OUTPUT); //Výstup pro připojení  reproduktoru 
   Serial.begin(9600); 
   lcd.begin(16, 2);  //pro jiný displej nutno nastavit
   lcd.setCursor(0,0);
   lcd.print("Nabijeni Li-Ion");

    digitalWrite(9, HIGH);
    delay (3000); 
    for(int i=0;i<100;i++){
    analog = analogRead(1);   // přepočet napětí na proud dle informací od výrobce
    napeti = (analog * 5000.0) / 1023.0;
    proud = (napeti - offset) / konstanta;   // uložení výsledku pro následné zprůměrování
    soucet += proud;
    delay(10); 
    tone(8,400,500);
    }

    Imax = (soucet/100);  // výpočet průměru ze stovky měření

 
    lcd.clear(); 
    lcd.setCursor(0, 1);
    lcd.print(" Max");
    lcd.print(Imax);
    lcd.print("A"); 
    delay (500);

  }

void loop() {
   
  cas_old=cas;          //odeslání hodnot na sériový port
  cas = millis()/60000;
 if (cas>=cas_old+1){
  Serial.print (cas);
  Serial.print (";");
  Serial.println (proud);
 }
 
  proud = 0;
  soucet = 0;

  lcd.setCursor(0, 0);      
  lcd.print (cas);
  lcd.print("min"); 
  lcd.print(" Max");    
  lcd.print(Imax);
  lcd.print("A"); 
 
  delay (500);
  
 
  for(int i=0;i<100;i++){
  analog = analogRead(1);   // přepočet napětí na proud dle informací od výrobce
  napeti = (analog * 5000.0) / 1023.0;
  proud = (napeti - offset) / konstanta;   // uložení výsledku pro následné zprůměrování
  soucet += proud;
  delay(10);
  }

  proud = (soucet/100);  // výpočet průměru ze stovky měření
  x=x+1;
  Isum=Isum+proud; //součet jednotlivých proudů 
 
    lcd.setCursor(0, 1);  //Tisk hodnot proudů na LCD
    lcd.print("Ie");
    lcd.print(Ivyp);    //zde můžeme místo Ivyp zobrazit proměnnou k 
    lcd.print("A");     //místo "A" můžeme zobrazit "%"
    lcd.print("  In");
    lcd.print(proud);
    lcd.print("A"); 
    delay (500); 
    
   int m = analogRead(0);   //získání hodnoty z potenciometru P2
   int k = map (m,0,1023,0,100); //přepočet hodnot na 0-100 
   
    Ivyp=Imax*k/100;  //Výpočet vypínacího proudu
    if (proud<Ivyp){
    digitalWrite(9, LOW);
    Iprum=Isum/x;    
    c=Iprum*cas*16.66666; //Výpočet kapacity v mAh
    
    lcd.clear();      //Tisk výsledků na LCD
    lcd.setCursor(0, 0); 
    lcd.print("Dokonceno t="); 
    lcd.print (cas);
    //lcd.print("min"); 
    lcd.setCursor(0, 1);  
    lcd.print("Ip"); 
    lcd.print(Iprum);
    lcd.print("A"); 
    lcd.print(" C"); 
    lcd.print(c,1);
    delay (500); 
    
 
    for (int j=1; j<10;j++){  //Zvuková signalizace ukončení nabíjení
        tone(8,400,1000);
        delay (3000);
    }
   
   
delay (10800000); //Zastavení programu na 3 hodiny pro pozdější přečtení hodnot
  
  }
 
      
    }
